
%global meadversion 1.1.6
%global namedversion 1.1.6.Final-redhat-1
%global meadalpha .Final_redhat_1
%global meadrel .1
%global serial 1
%global namedversionrel redhat-1

%bcond_with javadoc
%bcond_without mead

%define maven_version 1.1.6.Final-redhat-1

Name:           tomcat-vault
Version:        %{meadversion}
Release:        %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:          0
Summary:        Vault extension for Apache Tomcat
Group:          Development/Java

%if %with mead
Source100: tomcat-vault-1.1.6.Final-redhat-1-scm-sources.zip
Source102: tomcat-vault-1.1.6.Final-redhat-1-javadoc.jar
Source103: tomcat-vault-1.1.6.Final-redhat-1.jar
Source104: tomcat-vault-1.1.6.Final-redhat-1-jar-with-dependencies.jar
Source105: tomcat-vault-1.1.6.Final-redhat-1-sources.jar
Source106: tomcat-vault-1.1.6.Final-redhat-1.pom
Source107: tomcat-vault-1.1.6.Final-redhat-1-project-sources.tar.gz
%endif

License:        ASL 2.0
URL:            https://github.com/picketbox/tomcat-vault

# build/scripts patches
Requires:           jpackage-utils
Requires(post):     jpackage-utils
Requires(postun):   jpackage-utils
Requires:           java >= 1.7.0
Requires:           %{_docdir}/%{name}-%{version}/MARKER

BuildRequires:      jpackage-utils
BuildRequires:      java-devel >= 1.7.0

BuildArch:      noarch
BuildRoot:      %{_tmppath}/tomcat-vault-%{namedversion}-%{release}-root

Patch0:         vault.sh.patch

%description
%{summary}.

%if %with javadoc
%package javadoc
Summary:        Javadoc for tomcat-vault
Group:          Development/Documentation

Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildRequires:  unzip

%description javadoc
%{summary}.
%endif

%package zip
Summary:        Zip distribution for tomcat-vault
Group:          Development/Java

Provides:       tomcat-vault-zip = %{epoch}:%{version}-%{release}
BuildRequires:  zip

%description zip
%{summary}.

%package tomcat7
Summary:    Subpackage that depends on tomcat7 packages
Group:      Development/Java

Requires:           tomcat7
Requires:           tomcat7-lib
BuildRequires:      tomcat7
BuildRequires:      tomcat7-lib

%description tomcat7
%{summary}.

%package tomcat8
Summary:    Subpackage that depends on tomcat8 packages
Group:      Development/Java

Requires:           tomcat8
Requires:           tomcat8-lib
BuildRequires:      tomcat8
BuildRequires:      tomcat8-lib

%description tomcat8
%{summary}.

%prep
%setup -q -n tomcat-vault -T -b 100
%patch0 -p0

%build
%{__mkdir_p} %{_sourcedir}/bin
%{__cp} -p bin/vault.sh %{_sourcedir}/bin
%{__cp} -p bin/vault.bat %{_sourcedir}/bin
%{__cp} -p pom.xml %{_sourcedir}/

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/tomcat-vault-%{namedversion}.jar %{buildroot}%{_javadir}/tomcat-vault-%{namedversion}.jar
%if %with javadoc
    %{__cp} -p %{_sourcedir}/tomcat-vault-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/tomcat-vault-%{namedversion}-javadoc.jar
%endif
%{__cp} -p %{_sourcedir}/tomcat-vault-%{namedversion}-sources.jar %{buildroot}%{_javadir}/tomcat-vault-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# shell
%{__mkdir_p} %{buildroot}%{_bindir}
%{__cp} -p %{_sourcedir}/bin/vault.sh %{buildroot}%{_bindir}/tomcat-vault.sh

%{__cp} -p %{_sourcedir}/tomcat-vault-%{namedversion}-jar-with-dependencies.jar %{buildroot}%{_javadir}/
# For now, we want to use the jar-with-dependencies, so unlink and recreate the tomcat-vault.jar link
# TODO: Remove the following two lines after the CLI dependency issues are done
pushd %{buildroot}%{_javadir}
    unlink tomcat-vault.jar
    %{__ln_s} tomcat-vault-%{namedversion}-jar-with-dependencies.jar tomcat-vault.jar
    # Put a link to tomcat-vault on the tomcat7 and tomcat8 classpath
    mkdir tomcat7
    pushd tomcat7
        %{__ln_s} %{_javadir}/tomcat-vault.jar .
    popd
    mkdir tomcat8
    pushd tomcat8
        %{__ln_s} %{_javadir}/tomcat-vault.jar .
    popd
popd

%if %with javadoc
# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/tomcat-vault-%{namedversion}
%{_bindir}/unzip -qq %{_sourcedir}/tomcat-vault-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/tomcat-vault-%{namedversion} -x META-INF/\*
%{__ln_s} tomcat-vault-%{namedversion} %{buildroot}%{_javadocdir}/tomcat-vault
%endif

# zip file
mkdir -p tmp/tomcat-vault-%{version}/bin
mkdir -p tmp/tomcat-vault-%{version}/lib

pushd tmp
pushd tomcat-vault-%{version}/bin
%{__cp} -p %{buildroot}%{_bindir}/tomcat-vault.sh .
%{__cp} -p %{_sourcedir}/bin/vault.bat ./tomcat-vault.bat
popd
%{__cp} -p %{buildroot}%{_javadir}/tomcat-vault.jar tomcat-vault-%{version}/lib/

%{__mkdir_p} %{buildroot}%{_javadir}/%{name}-fordev
# Grab the tomcat jars needed for the zip
%{__cp} $(build-classpath tomcat8/tomcat-util) tomcat-vault-%{version}/lib/
# Build-classpath doesn't work with juli because it's in bin
%{__cp} %{_datadir}/tomcat8/bin/tomcat-juli.jar tomcat-vault-%{version}/lib/

%{_bindir}/zip -r -q %{buildroot}%{_javadir}/%{name}-fordev/tomcat-vault-%{namedversion}.zip tomcat-vault-%{version}/*
popd

rm -rf tmp

# Instead of using %%doc, copy files in place manually
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/
cp LICENSE ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/
cp *.md ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/
touch ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/MARKER

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
# %%doc included the SCL name, which we don't want to do
%{_docdir}/%{name}-%{version}/LICENSE
%{_docdir}/%{name}-%{version}/*.md
%{_javadir}/tomcat-vault-%{namedversion}.jar
%{_javadir}/tomcat-vault.jar
%{_bindir}/tomcat-vault.sh
%attr(0755,-,-) %{_bindir}/tomcat-vault.sh
%if %with javadoc
%{_javadir}/tomcat-vault-%{namedversion}-javadoc.jar
%{_javadir}/tomcat-vault-javadoc.jar
%endif
%{_javadir}/tomcat-vault-%{namedversion}-sources.jar
%{_javadir}/tomcat-vault-%{namedversion}-jar-with-dependencies.jar
%{_javadir}/tomcat-vault-sources.jar

%files tomcat7
%{_docdir}/%{name}-%{version}/MARKER
%{_javadir}/tomcat7/tomcat-vault.jar

%files tomcat8
%{_docdir}/%{name}-%{version}/MARKER
%{_javadir}/tomcat8/tomcat-vault.jar

%if %with javadoc
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/tomcat-vault-%{namedversion}
%{_javadocdir}/tomcat-vault
%endif

%files zip
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}-fordev
%{_javadir}/%{name}-fordev/tomcat-vault-%{namedversion}.zip

%changelog
* Thu Feb 08 2018 Patrick Sutherland <csutherl@redhat.com> - 1.1.6-1.Final_redhat_1.1
- JWS_3.1.0.SP2.ER1

* Thu Feb 08 2018 Coty Sutherland <csutherl@redhat.com> - 1.1.6-1.Final_redhat_1.1
- Build for JWS_3.1.0.SP2.ER1
- Resolves: JWS-904 tomcat-vault.sh CRYPT feature does not return the exit code 0 even if it runs successfully

* Mon Dec 18 2017 Coty Sutherland <csutherl@redhat.com> - 1.1.5-1.Final_redhat_1.1
- Build for JWS_3.1.0.SP1.DR2
- Resolves: JWS-861 Moving the CRYPT feature CLI into vault.sh and add an abitlity to specify the vault reference instead of plain text encryption password

* Thu Nov 30 2017 Patrick Sutherland <csutherl@redhat.com> - 1.1.4-1.Final_redhat_1.1
- JWS_3.1.0.SP1.DR1

* Wed Nov 29 2017 Coty Sutherland <csutherl@redhat.com> - 1.1.4-1.Final_redhat_1.1
- Resolves: JWS-281 Tomcat-vault rpm installation improvement
- Resolves: JWS-766 tomcat-vault packaging issues
- Resolves: JWS-749 tomcat-vault provides misinformation about how to get started
- Resolves: JWS-748 Remove JBoss dependencies from tomcat-vault where possible
- Resolves: JWS-757 some tomcat-vault errors are ignored and not logged

* Tue Dec 13 2016 Coty Sutherland <csutherl@redhat.com> - 1.0.8-9.Final_redhat_2.1
- Resolves: JWS-615

* Thu Dec 01 2016 Coty Sutherland <csutherl@redhat.com> - 1.0.8-8.Final_redhat_1.1
- 

* Thu Nov 17 2016 Coty Sutherland <csutherl@redhat.com> - 1.0.8-8.Final_redhat_6.1
- Resolves: JWS-589 Tomcat-vault Rpm wrong jar name
- Resolves: JWS-586 Tomcat-vault INSTALL file is wrong
- Resolves: JWS-582 Tomcat-vault cannot resolve JBOSS_HOME

* Wed Oct 26 2016 Coty Sutherland <csutherl@redhat.com> - 1.0.8-7.Final_redhat_6.1
- 

* Wed Oct 26 2016 Coty Sutherland <csutherl@redhat.com> - 1.0.8-6.Final_redhat_5.1
- 

* Wed Oct 26 2016 Coty Sutherland <csutherl@redhat.com> - 1.0.8-5.Final_redhat_4.1
- 

* Tue Sep 20 2016 Coty Sutherland <csutherl@redhat.com> - 1.0.8-5.Final_redhat_5.1
- Resolves: JWS-217 Tomcat vault .sh script JBOSS_MODULEPATH is not used

* Mon Oct 26 2015 Wei Nan Li <weli@redhat.com> - 1.0.8-4.Final_redhat_4.1
- 

* Sun Oct 25 2015 Wei Nan Li <weli@redhat.com> - 1.0.8-3.Final_redhat_3.1
- JWS-258

* Mon Oct 19 2015 Wei Nan Li <weli@redhat.com> - 1.0.8-2.Final_redhat_2.1
-

* Wed Oct 14 2015 Wei Nan Li <weli@redhat.com> - 1.0.8-1.Final_redhat_1.1
-

* Tue Oct 13 2015 Wei Nan Li <weli@redhat.com> - 1.0.7-2.Final_redhat_1.1
-

* Tue Sep 15 2015 Wei Nan Li <weli@redhat.com> - 1.0.6-4.Final_redhat_2.3
-

* Tue Sep 15 2015 Wei Nan Li <weli@redhat.com> - 1.0.6-3.Final_redhat_2.2
-

* Tue Sep 15 2015 Wei Nan Li <weli@redhat.com> - 1.0.6-2.Final_redhat_2.1
-

* Fri Sep 11 2015 Wei Nan Li <weli@redhat.com> - 1.0.6-1.Final_redhat_1.1
-

* Fri Sep 11 2015 Wei Nan Li <weli@redhat.com> - 1.0.5-2.Final_redhat_2.1
-

* Mon Aug 24 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.5-1.Final_redhat_1.1
-

* Mon Aug 24 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.4-5.Final_redhat_7.1
-

* Wed Aug 19 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.4-4.Final_redhat_6.1
-

* Tue Aug 18 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.4-3.Final_redhat_5.1
-

* Mon Aug 17 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.4-3.Final_redhat_4.1
-

* Mon Aug 17 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.4-3.Final_redhat_3.1
-

* Fri Aug 14 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.4-2.Final_redhat_2.3
- Add zip.

* Tue Aug 04 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.4-2.Final_redhat_2.2
-

* Tue Aug 04 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.4-2.Final_redhat_2.1
-

* Tue Aug 04 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.4-1.Final_redhat_1.1
-

* Mon Aug 03 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.3-5.Final_redhat_8.1
-

* Fri Jul 31 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.3-5.Final_redhat_7.1
-

* Thu Jul 30 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.3-5.Final_redhat_6.2
-

* Thu Jul 30 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.3-5.Final_redhat_6.1
-

* Thu Jul 30 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.3-4.Final_redhat_5.1
-

* Wed Jul 29 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.3-3.Final_redhat_4.2
-

* Wed Jul 29 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.3-2.Final_redhat_4.1
-

* Wed Jul 29 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.3-1.Final_redhat_3.3
-

* Wed Jul 29 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.3-1.Final_redhat_3.2
-

* Wed Jul 29 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.3-1.Final_redhat_3.1
-

* Wed Jul 29 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.3-1.Final_redhat_2.1
-

* Wed Jul 29 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.3-1.Final_redhat_1.1
-

* Wed Jul 01 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-9.Final_redhat_16.3
-

* Wed Jul 01 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_16.2
-

* Wed Jul 01 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_16.1
-

* Wed Jul 01 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_15.1
-

* Wed Jul 01 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_14.1
-

* Tue Jun 30 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_13.2
-

* Tue Jun 30 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_13.1
-

* Tue Jun 30 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_12.1
-

* Tue Jun 30 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_11.2
-

* Tue Jun 30 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-8.Final_redhat_11.1
-

* Mon Jun 29 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-8.Final_redhat_10.2
-

* Mon Jun 29 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-7.Final_redhat_10.1
-

* Mon Jun 29 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-6.Final_redhat_9.1
-

* Mon Jun 29 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-6.Final_redhat_8.1
-

* Mon Jun 29 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-6.Final_redhat_6.1
-

* Wed Jun 17 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-5.Final_redhat_5.3
-

* Wed Jun 17 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-4.Final_redhat_5.2
-

* Wed Jun 17 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-4.Final_redhat_5.1
-

* Tue Jun 16 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-3.Final_redhat_4.2
-

* Tue Jun 16 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-3.Final_redhat_4.1
-

* Tue Jun 16 2015 Maxime Beck <maxbeck@redhat.com> - 1.0.0-2.Final_redhat_3.5
- Add AS Security Module

* Fri Jun 12 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-2.Final_redhat_3.4
-

* Fri Jun 12 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-2.Final_redhat_3.3
-

* Fri Jun 12 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-2.Final_redhat_3.2
-

* Fri Jun 12 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-2.Final_redhat_3.1
-

* Fri Jun 12 2015 Jean-Frederic Clere <jclere@redhat.com> - 1.0.0-2.Final_redhat_2.1
-

* Thu Jun 11 2015 David Walluck <dwalluck@redhat.com> - 1.0.0-1.Final_redhat_1.1
- release
